/*
 * 循环返风控白名单
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserSwapWhiteController : BaseController
    {
        public UserSwapWhiteController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 循环返风控白名单列表

        /// <summary>
        /// 根据条件查询循环返风控白名单列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserSwapWhite data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            List<KqProducts> Brands = db.KqProducts.OrderBy(m => m.Id).ToList();
            ViewBag.Brands = Brands;
            return View();
        }

        #endregion

        #region 根据条件查询循环返风控白名单列表

        /// <summary>
        /// 循环返风控白名单列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserSwapWhite data, string MakerCode, string RealName, string StatusSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("BrandId", "0"); //品牌

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //状态
            if(!string.IsNullOrEmpty(StatusSelect))
            {
                condition += " and Status=" + StatusSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserSwapWhite", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                if (!string.IsNullOrEmpty(user.ParentNav))
                { 
                    int TopId = int.Parse(user.ParentNav.Trim(',').Replace(",,", ",").Split(',')[0]);
                    Users tuser = db.Users.FirstOrDefault(m => m.Id == TopId) ?? new Users();
                    dic["TopMakerCode"] = tuser.MakerCode;
                    dic["TopRealName"] = tuser.RealName;
                }
                dic["Status"] = dic["Status"].ToString() == "1" ? "有效" : "无效";
            }
            return Json(obj);
        }

        #endregion

        #region 增加循环返风控白名单

        /// <summary>
        /// 增加或修改循环返风控白名单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加循环返风控白名单

        /// <summary>
        /// 增加或修改循环返风控白名单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserSwapWhite data, string MakerCode)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            UserForMakerCode user = db.UserForMakerCode.FirstOrDefault(m => m.MakerCode == MakerCode);
            if (user == null)
            {
                return "创客编号不存在";
            }
            Fields.Add("UserId", user.UserId); //创客
            Fields.Add("BrandId", data.BrandId); //品牌
            Fields.Add("Remark", data.Remark); //备注
            Fields.Add("Status", data.Status); //状态

            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserSwapWhite", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserSwapWhite", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改循环返风控白名单

        /// <summary>
        /// 增加或修改循环返风控白名单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            UserSwapWhite editData = db.UserSwapWhite.FirstOrDefault(m => m.Id == Id) ?? new UserSwapWhite();
            ViewBag.data = editData;

            Users user = db.Users.FirstOrDefault(m => m.Id == editData.UserId) ?? new Users();
            ViewBag.MakerCode = user.MakerCode;
            return View();
        }

        #endregion

        #region 修改循环返风控白名单

        /// <summary>
        /// 增加或修改循环返风控白名单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserSwapWhite data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Remark", data.Remark); //备注
            Fields.Add("Status", data.Status); //状态

            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSwapWhite", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserSwapWhite", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除循环返风控白名单信息

        /// <summary>
        /// 删除循环返风控白名单信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserSwapWhite", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSwapWhite", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserSwapWhite", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSwapWhite", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserSwapWhite", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserSwapWhite", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserSwapWhite", Sort, Id);

            AddSysLog(Id.ToString(), "UserSwapWhite", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.UserSwapWhite.Add(new UserSwapWhite()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserSwapWhite", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserSwapWhite data, string MakerCode, string RealName, string StatusSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("BrandId", "0"); //品牌

            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(MakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + MakerCode + "')";
            }
            //创客名称
            if (!string.IsNullOrEmpty(RealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + RealName + "')";
            }
            //状态
            if(!string.IsNullOrEmpty(StatusSelect))
            {
                condition += " and Status=" + StatusSelect;
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserSwapWhite", Fields, "Id desc", "0", 1, 20000, condition, "UserId,BrandId,Remark,Status,Remark", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["BrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["BrandId"].ToString()));
                int UserId = int.Parse(dic["UserId"].ToString());
                Users user = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["MakerCode"] = user.MakerCode;
                dic["RealName"] = user.RealName;
                if (!string.IsNullOrEmpty(user.ParentNav))
                { 
                    int TopId = int.Parse(user.ParentNav.Trim(',').Replace(",,", ",").Split(',')[0]);
                    Users tuser = db.Users.FirstOrDefault(m => m.Id == TopId) ?? new Users();
                    dic["TopMakerCode"] = tuser.MakerCode;
                    dic["TopRealName"] = tuser.RealName;
                }
                dic["Status"] = dic["Status"].ToString() == "1" ? "有效" : "无效";
                dic.Remove("UserId");
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("MakerCode", "创客编号");
            ReturnFields.Add("RealName", "创客姓名");
            ReturnFields.Add("BrandId", "产品类型");
            ReturnFields.Add("Status", "有效状态");
            ReturnFields.Add("TopMakerCode", "顶级创客编号");
            ReturnFields.Add("TopRealName", "顶级创客名称");
            ReturnFields.Add("Remark", "备注");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserSwapWhite", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
